/*
 * grab.c by Antti Hyrinen. 
 *           ~g/RRR made some fixes & modifications
 *
 * This is the QWK packer/unpacker for VMatik. 
 *
 * Notes: At its present state this has quite ugly code. Besides, 
 * QWK is outdated. If anyone is interested in making a BlueWave 
 * or OMEN version out of this piece of junk, I'd greatly 
 * appreciate it.
 *
 */
#include "../lib/ddlib.h"
#include "struct.h"
#include <ctype.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>

void die(void);
void nuketmp(void);
void CpyToLAINA(char *, char *);
char *ecfg(char *hay, char *need);
int deldir(char *dir);
char *fgetsnolf(char *buf, int n, FILE *fh);
int myjoin(int confn);
int inttoms (int i, char c[4]);
int procqwkm(struct VMatik_Message *daheader);
int strupr (char *strh);
int maketmp(void);
int setlrps(void);
int skipmsg(int fd, char *qbl);
int mystrcpy(char *d, char *s, int l);
int makeqwk(void);
int getqwk(void);
int removespaces(char *strh);
int get_virtual_conf(int confn, int basen);
int get_conf_virt(int virt);
int findtmpnc(char *file, char *dname);

struct dif *d;
char *cfg;
int node;
unsigned short mcount=0;

struct VMatik_MainConfig maincfg;
char bbsid[20];
char unzip[128];
struct VMatik_LRP lp;
struct VMatik_MsgPointers mp;
struct VMatik_Conference *confs;
struct VMatik_Conference *conf;
struct VMatik_MsgBase *base;
FILE *msgdfd;
int ndxfd;
int blk_cnt=2;
int cconf;

void main(int argc, char *argv[])
{
	char buf[1024];
	int i;
	struct stat st;
	int cfgfd;
	char *cptr;
	
	if (argc==1) {
		printf("This program requires MS Windows!\n");
		exit(1);
	}
	d=VMatik_initdoor(argv[1]);
	if (d==0) {
		printf("Couldn't find socket!\n");
		exit(1);
	}
	cconf=VMatik_getintval(d,VCONF_NUMBER);
	VMatik_changestatus(d,"Grabbing messages");
	
	atexit(die);
	VMatik_sendstring(d,"\n[35mDD-Grab V1.0 by Antti Hyrynen.\n\n");
	node=atoi(argv[1]);
	
	sprintf(buf,"%s/configs/dd-grab.cfg",getenv("VMATIK"));

	if (stat(buf,&st)==-1) {
		VMatik_sendstring(d,"[37mCouldn't find configfile!\n\n");
		exit(0);
	}
	cfg=(char *)malloc(st.st_size+2);
		
	cfgfd=open(buf,O_RDONLY);
	i=read(cfgfd,cfg,st.st_size);
	close(cfgfd);
	cfg[i]=0;

	cptr=ecfg(cfg,"BBSID \"");
	if(cptr)
		CpyToLAINA(cptr,bbsid);
	else 
		exit(0);
	
	cptr=ecfg(cfg, "UNZIP \"");
	if(cptr)
		CpyToLAINA(cptr,unzip);
	else
		strcpy(unzip,"unzip -jqq");

	sprintf(buf,"%s/data/vmatik.dat",getenv("VMATIK"));
	cfgfd=open(buf,O_RDONLY);
	read(cfgfd,&maincfg,sizeof(struct VMatik_MainConfig));
	close(cfgfd);
	
	VMatik_sendstring(d,"[36mDo you want to [0mD[34m)[36mownload or [0mU[34m)[36mpload QWK packet?: [0m");
	*buf=0;
	if (!(VMatik_prompt(d,buf,3,0))) exit(0);
	if (toupper(*buf)=='D') {
		makeqwk();
	} else if (toupper(*buf)=='U') {
		getqwk();
	}
}

int getqwk(void)
{
	char qbuf[1024];
	char tname[1024];
	char olddir[1024];
	int msgfd;
	int bolloks;
	char qwkblock[128];
	int repfd;
	
	if (!maketmp()) 
		return 0;
	atexit(nuketmp);

	confs=VMatik_getconfdata();
	if (!confs) return 0;

	sprintf(qbuf,"%sdd-grab%d/",VMTMP,node);
	VMatik_getfiles(d,qbuf);	

	getcwd(olddir,1024);
	sprintf(qbuf,"%sdd-grab%d/",VMTMP,node);
	chdir(qbuf);
	sprintf(qbuf,"%s.rep",bbsid);
	if (findtmpnc(qbuf,tname)) {
		sprintf(qbuf,"%s %s </dev/null >/dev/null 2>/dev/null",unzip,tname);
		system(qbuf);
	}
	sprintf(qbuf,"%s.msg",bbsid);
	if (findtmpnc(qbuf,tname)) {
		repfd=open(tname,O_RDONLY);
		if (repfd > -1) {
			read(repfd,&qwkblock,128);
			if (!strncasecmp(qwkblock,bbsid,strlen(bbsid))) {
				while(read(repfd,&qwkblock,128))
				{
					int confn;
					struct VMatik_Message msg;
					char usr[80];
					char receiver[80];
					char ebuf[1024];
					
					confn=atoi(&qwkblock[1]);
					memset(&msg,0,sizeof(struct VMatik_Message));
					if (!get_conf_virt(confn)) {
						VMatik_sendstring(d,"Unknown conf!\n");
						skipmsg(repfd,qwkblock);
						continue;
					}
					if (!VMatik_joinconf(d,conf->CONF_NUMBER,JC_QUICK|JC_SHUTUP)) {
						skipmsg(repfd,qwkblock);
						continue;
					}
					VMatik_changemsgbase(d,base->MSGBASE_NUMBER,MC_QUICK|MC_NOSTAT);
					if (base->MSGBASE_FLAGS & (1L<<2)) {
						VMatik_getstrval(d,usr,USER_HANDLE);
					} else {
						VMatik_getstrval(d,usr,USER_REALNAME);
					}
					strcpy(msg.MSG_AUTHOR,usr);
					mystrcpy(receiver,&qwkblock[21],25);
					if (!strcasecmp(receiver,"All")) {
						*msg.MSG_RECEIVER=0;
					} else if (!strcasecmp(receiver,"EAll")) {
						*msg.MSG_RECEIVER=255;
					} else {
						strncpy(msg.MSG_RECEIVER,receiver,25);
					}
					mystrcpy(msg.MSG_SUBJECT,&qwkblock[71],25);
					msg.MSG_CREATION=time(0);
					if (*qwkblock==' ' || *qwkblock=='-' ||  base->MSGBASE_FLAGS & (1L<<1)) {
						
					} else {
						msg.MSG_FLAGS |= (1L<<0);
					}
					VMatik_getmprs(d,&mp);
					mp.msp_high++;
					msg.MSG_NUMBER=mp.msp_high;
					VMatik_setmprs(d,&mp);
					sprintf(qbuf,"%smessages/base%3.3d/msgbase.dat",conf->CONF_PATH,base->MSGBASE_NUMBER);

					if ((msgfd=open(qbuf,O_RDWR|O_CREAT,0664)) < 0) {
						skipmsg(repfd,qwkblock);
					}
					lseek(msgfd,0,SEEK_END);
					if (toupper(base->MSGBASE_FN_FLAGS)=='E') {
						msg.MSG_FN_ORIG_ZONE=base->MSGBASE_FN_ZONE;
						msg.MSG_FN_ORIG_NET=base->MSGBASE_FN_NET;
						msg.MSG_FN_ORIG_NODE=base->MSGBASE_FN_NODE;
						msg.MSG_FN_ORIG_POINT=base->MSGBASE_FN_POINT;
						msg.MSG_FLAGS |= (1L<<2);
					}

					write(msgfd,&msg,sizeof(struct VMatik_Message));
					close(msgfd);
		
					sprintf(qbuf,"%smessages/base%3.3d/msg%5.5d",conf->CONF_PATH,base->MSGBASE_NUMBER,msg.MSG_NUMBER);
	
					msgfd=open(qbuf,O_CREAT|O_WRONLY,0644);
					if (toupper(base->MSGBASE_FN_FLAGS)=='E') {
						char ub[128];
						char ebuf[1024];
						int uq;
		
						strcpy(ub,base->MSGBASE_FN_TAG);
						strupr(ub);
						sprintf(ebuf,"AREA:%s\n",ub);
						write(msgfd,ebuf,strlen(ebuf));
						uq=VMatik_getfidounique();
						if(uq)
						{
							sprintf(ebuf,"\001MSGID: %d:%d/%d.%d %8.8x\n",base->MSGBASE_FN_ZONE,base->MSGBASE_FN_NET,base->MSGBASE_FN_NODE,base->MSGBASE_FN_POINT,uq);
							write(msgfd,ebuf,strlen(ebuf));
						}

					}
					bolloks=atoi(&qwkblock[116])-1;
					while(bolloks--)
					{
						unsigned char qwb[130];
						int i;
						
						read(repfd,&qwb,128);
						for(i=0;i<129;i++) if (qwb[i]==227) qwb[i]=10;
						if (!bolloks) {
							qwb[128]=0;
							removespaces(qwb);
							write(msgfd,&qwb,strlen(qwb));
						} else write(msgfd,&qwb,128);
					}
					if (toupper(base->MSGBASE_FN_FLAGS)=='E') {
						sprintf(ebuf,"\n--- VMatik BBS/Linux %s\n * Origin: %s (%d:%d/%d)\nSEEN-BY: %d/%d\n",versionstring,base->MSGBASE_FN_ORIGIN,base->MSGBASE_FN_ZONE,base->MSGBASE_FN_NET,base->MSGBASE_FN_NODE,base->MSGBASE_FN_NET,base->MSGBASE_FN_NODE);
						write(msgfd,ebuf,strlen(ebuf));
					}					
					close(msgfd);
					sprintf(qbuf,"[36mMessage posted to [0m%s[34m/[0m%s[36m.\n",conf->CONF_NAME,base->MSGBASE_NAME);
					VMatik_sendstring(d,qbuf);
				}
			}
		}
	} else {	
		VMatik_sendstring(d,"\n[35mCan't find message packet!\n\n");
	}
	chdir(olddir);

	return(1);
}

int mystrcpy(char *d, char *s, int l)
{
	strncpy(d,s,l);
	removespaces(d);

	return(1);
}

int removespaces(char *strh)
{
	char *s;
	s=strh;
	if (!*s) 
		return(0);
		
	while(*s) s++;
	s--;
	while (*s==' ') s--;
	*(s+1)=0;

	return(1);
}

int skipmsg(int fd, char *qbl)
{
	lseek(fd,(atoi(&qbl[116])-1)*128,SEEK_CUR);

	return(1);
}

int findtmpnc(char *file, char *dname)
{
	char tbuf[1024];
	DIR *dh;
	struct dirent *dent;
	
	sprintf(tbuf,"%sdd-grab%d/",VMTMP,node);

	dh=opendir(tbuf);
	if(dh)
	{
		while((dent=readdir(dh)))
		{
			if (!strcmp(dent->d_name,".") || (!strcmp(dent->d_name,".."))) continue;
			if (!strcasecmp(dent->d_name,file)) {

				closedir(dh);
				strcpy(dname,dent->d_name);
				return 1;
			}
		}
		closedir(dh);
	}
	return 0;
}

int makeqwk(void)
{
	char qbuf[1024];
	time_t t;
	struct tm *tm;
	char username[80];
	FILE *ctrl;
	struct stat st;
	int ccount=0;
	int vc=0;
		
	t=time(0);
	tm=localtime(&t);
		
	VMatik_getstrval(d,username,USER_HANDLE);
	
	if (!maketmp()) return 0;
	atexit(nuketmp);

//	VMatik_sendstring(d, "Debu!\n");

	confs=(struct VMatik_Conference *)VMatik_getconfdata();
	if (!confs) 
		return 0;
	conf=confs;

//	VMatik_sendstring(d, "Yebu!\n");
	sprintf(qbuf,"%sdd-grab%d/messages.dat",VMTMP,node);
	msgdfd=fopen(qbuf,"w");
	if(!msgdfd) 
		return(0);
	
	fprintf(msgdfd,"%-128.128s","Produced by Qmail...Copyright (c) 1987 by Sparkware.  All rights Reserved");
	
	sprintf(qbuf,"%sdd-grab%d/control.dat",VMTMP,node);
	ctrl=fopen(qbuf,"w");
	if(!ctrl)
		return(0);
	
	fprintf(ctrl,"%s\r\n%s\r\n%s\r\n%s, Sysop\r\n",maincfg.CFG_BOARDNAME,"Location","Phone",maincfg.CFG_SYSOPNAME);
	fprintf(ctrl,"00000,%s\r\n%-2.2d-%2.2d-%-4.4d,%-2.2d:%-2.2d:%-2.2d\r\n%s\r\n\r\n0\r\n",bbsid,tm->tm_mon+1,tm->tm_mday,1900+tm->tm_year,tm->tm_hour,tm->tm_min,tm->tm_sec,username);
	
	VMatik_sendstring(d,"\n[35mPacking new messages\n\nConference                           Message Base          Progress\n");
	VMatik_sendstring(d,"[34m---------------------------------------------------------------------------\n");

	while(1)
	{
		int newcnt;
		char mailbuf[1024];
	
//		sprintf(mailbuf, "Numba: %d\n", conf->CONF_NUMBER);
//		VMatik_sendstring(d, mailbuf);
		
		if (conf->CONF_NUMBER==255) 
			break;

//		VMatik_sendstring(d, "haba!\n");
	
		if (myjoin(conf->CONF_NUMBER)) 
		{
			int confv=0;
			int bcnt;
		
//			VMatik_sendstring(d, "Laaba!\n");
			base=conf->Conf_MsgBases;
//			sprintf(buffa, "N: %d\n", conf->CONF_MSGBASES);
//			VMatik_sendstring(d, buffa);
			
//			sprintf(buffa, "Hoo: %d\n", conf->CONF_MSGBASES);
//			VMatik_sendstring(d, buffa);
			for(bcnt=0;bcnt<conf->CONF_MSGBASES;bcnt++)
			{
				int basefd;
				char *cn;
//				sprintf(buffa, "JEP: %d\n", base->MSGBASE_NUMBER);
//				VMatik_sendstring(d, buffa);

				newcnt=0;
				ccount++;
//				VMatik_changemsgbase(d,base->MSGBASE_NUMBER,MC_QUICK|MC_NOSTAT);
//				sprintf(buffa, "C: %d\n", bcnt);
//				VMatik_sendstring(d, buffa);
				
				
				if (VMatik_isbasetagged(d,conf->CONF_NUMBER,base->MSGBASE_NUMBER)) {
					newcnt=0;
//				sprintf(buffa, "A: %d\n", bcnt);
//				VMatik_sendstring(d, buffa);

					if (!confv) {
						cn=conf->CONF_NAME;
						confv=1;
					} else {
						cn=" ";
					}
					sprintf(mailbuf,"[33m%-37.37s[32m%-21.21s[36m ",cn,base->MSGBASE_NAME);
					VMatik_sendstring(d,mailbuf);
					VMatik_getmprs(d,&mp);
					VMatik_getlprs(d,&lp);

					if (!*base->MSGBASE_FN_TAG) {
						VMatik_sendstring(d,"[31mNo tag!\n");
						continue;
					}

//				sprintf(buffa, "C: %d\n", bcnt);
//				VMatik_sendstring(d, buffa);
					sprintf(qbuf,"%sdd-grab%d/%3.3d.ndx",VMTMP,node,get_virtual_conf(conf->CONF_NUMBER,base->MSGBASE_NUMBER));
					ndxfd=open(qbuf,O_TRUNC|O_CREAT|O_WRONLY,0644);
					if (mp.msp_high > lp.lrp_read) {
						struct VMatik_Message msg;
						int seekp;
						
						sprintf(mailbuf,"%smessages/base%3.3d/msgbase.dat",conf->CONF_PATH,base->MSGBASE_NUMBER);
						basefd=open(mailbuf,O_RDONLY);
						if (basefd==-1) 
							continue;
						
						fstat(basefd,&st);
						seekp=st.st_size-(mp.msp_high-lp.lrp_read+2)*sizeof(struct VMatik_Message);
						if (seekp < 0) seekp=0;
						lseek(basefd,seekp,SEEK_SET);
						while(read(basefd,&msg,sizeof(struct VMatik_Message)))
						{
							if (procqwkm(&msg)) newcnt++;
						}
						close(basefd);
					}
					close(ndxfd);
					
					if (newcnt) {
						sprintf(mailbuf,"%d new msgs\n",newcnt);
						VMatik_sendstring(d,mailbuf);
					} else {
						sprintf(qbuf,"%sdd-grab%d/%3.3d.ndx",VMTMP,node,get_virtual_conf(conf->CONF_NUMBER,base->MSGBASE_NUMBER));
						unlink(qbuf);
						VMatik_sendstring(d,"No new messages\n");
					}
				}
//				sprintf(buffa, "D: %d\n", bcnt);
//				VMatik_sendstring(d, buffa);
				base++;
			}
		}

		conf++;
	}
	
	fprintf(ctrl,"%d\r\n%d\r\n",mcount,ccount-1);
	conf=confs;

	while(1)
	{
		int bcnt;
		
		if (conf->CONF_NUMBER==255) 
			break;
	
		base=conf->Conf_MsgBases;
		bcnt=conf->CONF_MSGBASES;

		for(bcnt=conf->CONF_MSGBASES;bcnt;bcnt--,base++)
		{
			vc++;
			fprintf(ctrl,"%d\r\n%-13.13s\r\n",vc,base->MSGBASE_FN_TAG);
		}
		conf++;
	}

	fprintf(ctrl,"\r\n\r\n\r\n");
	fclose(ctrl);
	fclose(msgdfd);
		
	VMatik_sendstring(d,"[34m---------------------------------------------------------------------------\n");
	if (mcount) {
		char cdir[1024];
		FILE *fl;
		
		sprintf(qbuf,"[36m%d messages archived. Compressing with zip... ",mcount);
		VMatik_sendstring(d,qbuf);
		getcwd(cdir,1024);
		sprintf(qbuf,"%sdd-grab%d",VMTMP,node);
		chdir(qbuf);
		sprintf(qbuf,"zip >/dev/null 2>/dev/null </dev/null %s.qwk *",bbsid);
		system(qbuf);
		VMatik_sendstring(d,"OK!\n");

//		sleep(500000);

		sprintf(qbuf,"%sdd-grab%d/dltemp.lst",VMTMP,node);
		fl=fopen(qbuf,"w");
		if(fl)
		{
			fprintf(fl,"%sdd-grab%d/%s.qwk\n",VMTMP,node,bbsid);
			fclose(fl);
			VMatik_sendfiles(d,qbuf);
		}
		chdir(cdir);

		setlrps();
	}
	
	return(1);
}

int setlrps(void)
{
	VMatik_sendstring(d,"[36mSet last read pointers? [32m([33mYes[32m/[33mno[32m)[34m: [0m");
	conf=confs;
	
	if (VMatik_hotkey(d,HOT_YESNO)==1) {
	
		while(1)
		{
			int bcnt;
		
			if (conf->CONF_NUMBER==255) 
				break;
		
			if (myjoin(conf->CONF_NUMBER)) 
			{
				base=conf->Conf_MsgBases;	
				bcnt=conf->CONF_MSGBASES;
				for(bcnt=conf->CONF_MSGBASES;bcnt;bcnt--,base++)
				{
					VMatik_changemsgbase(d,base->MSGBASE_NUMBER,MC_QUICK|MC_NOSTAT);
					if (VMatik_isbasetagged(d,conf->CONF_NUMBER,base->MSGBASE_NUMBER)) {
						VMatik_getmprs(d,&mp);
						VMatik_getlprs(d,&lp);
					
						lp.lrp_read=lp.lrp_scan=mp.msp_high;

						VMatik_setlprs(d,&lp);
					}

				}
			}
			conf++;
		}
	}

	return(1);
}

int procqwkm(struct VMatik_Message *daheader)
{
	char realname[40];
	char handle[40];
	char msgstatus=' ';
	char msgname[1024];
	struct stat st;
	unsigned short vc;
	unsigned char vc2;
	char mspervo[4];
	int end_offset;
	int n;
	int out_bytes;
	char *rec;
	char msgbuf[1024];
	FILE *msgf;
	struct tm *tm;
	
	
	VMatik_getstrval(d,realname,USER_REALNAME);
	VMatik_getstrval(d,handle,USER_HANDLE);
	
	if (daheader->MSG_NUMBER > lp.lrp_read ) {
		if (daheader->MSG_FLAGS & (1L<<0)) {
			msgstatus='+';

			if ((!strcasecmp(daheader->MSG_AUTHOR,realname)) || (!strcasecmp(daheader->MSG_AUTHOR,handle)) || (!strcasecmp(daheader->MSG_RECEIVER,handle)) || (!strcasecmp(daheader->MSG_RECEIVER,realname))) {
		
			} else {
				return 0;
			}
		} else {
			if (daheader->MSG_RECEIVED) msgstatus='-';
		}		

	} else return 0;

	sprintf(msgname,"%smessages/base%3.3d/msg%5.5d",conf->CONF_PATH,base->MSGBASE_NUMBER,daheader->MSG_NUMBER);
	if (stat(msgname,&st)==-1) return 0;
	
	msgf=fopen(msgname,"r");
	if (!msgf) return 0;

	end_offset=st.st_size;
		
	tm=localtime(&daheader->MSG_CREATION);
	switch(*daheader->MSG_RECEIVER)
	{
		case 0:
			rec="All users";
			break;
		case -1:
			rec="<*> All users <*>";
			break;
		default:
			rec=daheader->MSG_RECEIVER;
			break;
	}
	fprintf(msgdfd,"%c%-7d%2.2d-%2.2d-%2.2d%-2.2d:%-2.2d%-25.25s%-25.25s%-25.25s%-12.12s%-8.8s",msgstatus,daheader->MSG_NUMBER,tm->tm_mon+1,tm->tm_mday,tm->tm_year,tm->tm_hour,tm->tm_min,rec,daheader->MSG_AUTHOR,daheader->MSG_SUBJECT," "," ");	fprintf(msgdfd,"%-6d",2+end_offset/128);
	vc=get_virtual_conf(conf->CONF_NUMBER,base->MSGBASE_NUMBER);
	vc2=vc;

	
	fwrite(&vc,2,1,msgdfd);
	mcount++;
	fwrite(&mcount,2,1,msgdfd);
	fputc(' ',msgdfd);

	out_bytes = 0;

	while (NULL != fgetsnolf (msgbuf, 1024, msgf))
	{
		n = strlen (msgbuf);
		fwrite (msgbuf, n, 1, msgdfd);
		out_bytes += n;

		if (n < 1024-1)
		{
			fputc (227, msgdfd);
			out_bytes++;
		}
	}

	/* Pad block as necessary */
	n = out_bytes % 128;
	for (;n<128;n++) fputc (' ', msgdfd);

	inttoms(blk_cnt,mspervo);
	blk_cnt += 1+end_offset/128;
	write(ndxfd,&mspervo,4);
	write(ndxfd,&vc2,1);
	return 1;
}

/* inttoms ripped from uqwk */

int inttoms (int i, char c[4])
/*
 *  Convert an integer into the Microsoft Basic floating format.
 *  This is the dumbest thing in the whole QWK standard.  Why in
 *  the world store block offsets as floating point numbers?
 *  Stupid!
 */
{
	int m, e;

	if (i == 0)
	{
		c[0] = c[1] = c[2] = 0;
		c[3] = 0x80;
		return(0);
	}

	e = 152;
	m = 0x7fffff & i;

	while (!(0x800000 & m))
	{
		m <<= 1;
		e--;
	}
	c[0] = 0xff & m;
	c[1] = 0xff & (m >> 8);
	c[2] = 0x7f & (m >> 16);
	c[3] = 0xff & e;
	return(0);
}

int myjoin(int confn)
{
	if (!VMatik_isanybasestagged(d,confn)) return 0;
	if (!VMatik_joinconf(d,confn,JC_QUICK|JC_SHUTUP)) return 0;
	return 1;
}

void nuketmp(void)
{
	char tb[1024];
	sprintf(tb,"%sdd-grab%d",VMTMP,node);
	deldir(tb);
	rmdir(tb);
}

int deldir(char *dir)
{
	DIR *dirfd;
	struct dirent *ent;
	char tempbuf[1024];

	dirfd=opendir(dir);
	if(dirfd)
	{
		while((ent=readdir(dirfd)))
		{
			struct stat st;

			if ( (ent->d_name[0]=='.' && ent->d_name[1]==0) || (ent->d_name[0]=='.' && ent->d_name[1]=='.' && ent->d_name[2]==0)) continue;
			sprintf(tempbuf,"%s/%s",dir,ent->d_name);
			stat(tempbuf,&st);
			if (S_ISDIR(st.st_mode)) {
				deldir(tempbuf);
				rmdir(tempbuf);
			} else {
				unlink(tempbuf);
			}
		}
		closedir(dirfd);
	} 

	return(1);
}

int maketmp(void)
{
	char tb[1024];
	sprintf(tb,"%sdd-grab%d",VMTMP,node);
	nuketmp();
	if (mkdir(tb,0755)==0) 
		return 1;
	
	VMatik_sendstring(d, "mkdir() failed!\n");

	return 0;
}

void die(void)
{
	VMatik_joinconf(d,cconf,JC_QUICK|JC_SHUTUP);
	VMatik_close(d);
}

char *ecfg(char *hay, char *need)
{
	char *s;
	while(1)
	{
		s=need;
		if (*hay==0) return 0;
		if (*hay==';') { 
			while(*hay!=10) {
				if(*hay==0) return 0;
				hay++;
			}
			continue;
		}
		while (1) {
			if (*s++==*hay++) {
				if (*s==0) return hay;
			} else {
				break;
			}
		}
	}
}

void CpyToLAINA(char *src, char *dest)
{
int i=0;

	while (src[i]!='\"') {
		dest[i]=src[i];
		i++;
	}
	dest[i]=0;
}

int get_virtual_conf(int confn, int basen)
{
	struct VMatik_Conference *mconf;
	struct VMatik_MsgBase *mbase;
	
	int i=1;
	mconf=confs;
	
	while(1)
	{
		int bcnt;
		if(mconf->CONF_NUMBER==255) 
			break;
	
		mbase=mconf->Conf_MsgBases;
		bcnt=mconf->CONF_MSGBASES;
	
		for(bcnt=mconf->CONF_MSGBASES;bcnt;bcnt--,mbase++)
		{
			if (mbase->MSGBASE_NUMBER==basen && mconf->CONF_NUMBER==confn)
				return(i);
			i++;  
		}	
		mconf++;
	}

	return(1);
}

int get_conf_virt(int virt)
{
	struct VMatik_Conference *mconf;
	struct VMatik_MsgBase *mbase;
	
	int i=1;
	mconf=confs;
	
	while(1)
	{
		int bcnt;
		if (mconf->CONF_NUMBER==255) 
			break;
	
		mbase=mconf->Conf_MsgBases;
		for(bcnt=mconf->CONF_MSGBASES;bcnt;bcnt--,mbase++)
		{
			if (virt==i) {
				conf=mconf;
				base=mbase;
				return 1;
			}
			i++;  
		}	
		mconf++;
	}
	return 0;
}

char * fgetsnolf(char *buf, int n, FILE *fh)
{
	char *hih;
	char *s;
	
	hih=fgets(buf,n,fh);
	if (!hih) return 0;
	s=buf;
	while (*s)
	{
		if (*s==13 || *s==10) {
			*s=0;
			break;
		}
		s++;
	}
	return hih;
}

int strupr (char *strh)
{
	while (*strh)
	{
		*strh++=toupper(*strh);
	}

	return(1);
}
